// RndWnd1.cpp:     .
//

#include "stdafx.h"
#include "RndWnd1.h"

// 
#define MAX_LOADSTRING		100
#define MAIN_WIN_SIZE		100

//  :
HINSTANCE hInst;								//  
TCHAR szTitle[MAX_LOADSTRING];			//   
TCHAR szWindowClass[MAX_LOADSTRING];	//    
HMENU hMainMenu = NULL;						//  

//   ,     :
ATOM				MyRegisterClass(HINSTANCE hInstance);
BOOL				InitInstance(HINSTANCE, int);
LRESULT CALLBACK	WndProc(HWND, UINT, WPARAM, LPARAM);
INT_PTR CALLBACK	About(HWND, UINT, WPARAM, LPARAM);

int APIENTRY _tWinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPTSTR    lpCmdLine,
                     int       nCmdShow)
{
	UNREFERENCED_PARAMETER(hPrevInstance);
	UNREFERENCED_PARAMETER(lpCmdLine);

 	// TODO:   .
	MSG msg;
	HACCEL hAccelTable;

	//   
	LoadString(hInstance, IDS_APP_TITLE, szTitle, MAX_LOADSTRING);
	LoadString(hInstance, IDC_RNDWND1, szWindowClass, MAX_LOADSTRING);
	MyRegisterClass(hInstance);

	//   :
	if (!InitInstance (hInstance, nCmdShow))
	{
		return FALSE;
	}

	hAccelTable = LoadAccelerators(hInstance, MAKEINTRESOURCE(IDC_RNDWND1));

	//   :
	while (GetMessage(&msg, NULL, 0, 0))
	{
		if (!TranslateAccelerator(msg.hwnd, hAccelTable, &msg))
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}

	return (int) msg.wParam;
}

//
//  : MyRegisterClass()
//
//  :   .
//
//  :
//
//            ,  ,   
//        Win32,    RegisterClassEx'
//        Windows 95.      ,
//       ""     
//     .
//
ATOM MyRegisterClass(HINSTANCE hInstance)
{
	WNDCLASSEX wcex;

	wcex.cbSize = sizeof(WNDCLASSEX);

	wcex.style				= CS_HREDRAW | CS_VREDRAW;
	wcex.lpfnWndProc		= WndProc;
	wcex.cbClsExtra		= 0;
	wcex.cbWndExtra		= 0;
	wcex.hInstance			= hInstance;
	wcex.hIcon				= LoadIcon(hInstance, MAKEINTRESOURCE(IDI_RNDWND1));
	wcex.hCursor			= LoadCursor(NULL, IDC_ARROW);
	wcex.hbrBackground	= (HBRUSH)(COLOR_WINDOW+1);
	wcex.lpszMenuName		= NULL;
	wcex.lpszClassName	= szWindowClass;
	wcex.hIconSm			= LoadIcon(wcex.hInstance, MAKEINTRESOURCE(IDI_SMALL));

	return RegisterClassEx(&wcex);
}

//
//   : InitInstance(HINSTANCE, int)
//
//   :       .
//
//   :
//
//                ,  
//               .
//
BOOL InitInstance(HINSTANCE hInstance, int nCmdShow)
{
   HWND hWnd;

   hInst = hInstance;

	//   
	hMainMenu = LoadMenu(hInstance, MAKEINTRESOURCE(IDC_RNDWND1));

	//    ( WS_POPUP)   MAIN_WIN_SIZE
   hWnd = CreateWindow(szWindowClass, szTitle, WS_POPUP,
							  10, 10, MAIN_WIN_SIZE, MAIN_WIN_SIZE, NULL, NULL, hInstance, NULL);

   if (!hWnd)
   {
      return FALSE;
   }

	//   
	HRGN hMainWndRgn = ::CreateEllipticRgn(0, 0, MAIN_WIN_SIZE, MAIN_WIN_SIZE);
	//      
	::SetWindowRgn(hWnd, hMainWndRgn, FALSE);

   ShowWindow(hWnd, nCmdShow);
   UpdateWindow(hWnd);

   return TRUE;
}

//
//  : WndProc(HWND, UINT, WPARAM, LPARAM)
//
//  :      .
//
//  WM_COMMAND	-   
//  WM_PAINT	-  
//  WM_DESTROY	 -      .
//
//
LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	int wmId, wmEvent;
	PAINTSTRUCT ps;
	HDC hdc;
	static int iMouseCapture_xPos;
	static int iMouseCapture_yPos;

	switch (message)
	{
	//   
	case  WM_CONTEXTMENU:
		{
			//   
			int xPos = GET_X_LPARAM(lParam); 
			int yPos = GET_Y_LPARAM(lParam);

			//  
			::TrackPopupMenuEx(::GetSubMenu(hMainMenu, 0), TPM_LEFTALIGN | TPM_TOPALIGN, xPos, yPos, hWnd, NULL);
		}
		return 0;
	//     
	case WM_LBUTTONDOWN:
		{
			//   
			int xPos = GET_X_LPARAM(lParam); 
			int yPos = GET_Y_LPARAM(lParam);
			//  
			iMouseCapture_xPos = xPos;
			iMouseCapture_yPos = yPos;
			SetCapture(hWnd);
		}
		return 0;
	//  
	case WM_MOUSEMOVE:
		if (GetCapture() == hWnd)
		{//  
			//   
			int xPos = GET_X_LPARAM(lParam); 
			int yPos = GET_Y_LPARAM(lParam);
			//  
			RECT WndRect;
			::GetWindowRect(hWnd, &WndRect);
			int iOffset_xPos = xPos - iMouseCapture_xPos;
			int iOffset_yPos = yPos - iMouseCapture_yPos;
			::SetWindowPos(hWnd, NULL, WndRect.left + iOffset_xPos, WndRect.top + iOffset_yPos, 0, 0, SWP_NOZORDER | SWP_NOSIZE);
		}
		return 0;
	//    
	case WM_LBUTTONUP:
		if (GetCapture() == hWnd)
		{//  
			//  
			::ReleaseCapture();
		}
		return 0;
	case WM_COMMAND:
		wmId    = LOWORD(wParam);
		wmEvent = HIWORD(wParam);
		//    :
		switch (wmId)
		{
		case IDM_ABOUT:
			DialogBox(hInst, MAKEINTRESOURCE(IDD_ABOUTBOX), hWnd, About);
			break;
		case IDM_EXIT:
			DestroyWindow(hWnd);
			break;
		default:
			return DefWindowProc(hWnd, message, wParam, lParam);
		}
		break;
	case WM_PAINT:
		hdc = BeginPaint(hWnd, &ps);
		// TODO:    ...
		EndPaint(hWnd, &ps);
		break;
	case WM_DESTROY:
		PostQuitMessage(0);
		break;
	default:
		return DefWindowProc(hWnd, message, wParam, lParam);
	}
	return 0;
}

//     " ".
INT_PTR CALLBACK About(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	UNREFERENCED_PARAMETER(lParam);
	switch (message)
	{
	case WM_INITDIALOG:
		return (INT_PTR)TRUE;

	case WM_COMMAND:
		if (LOWORD(wParam) == IDOK || LOWORD(wParam) == IDCANCEL)
		{
			EndDialog(hDlg, LOWORD(wParam));
			return (INT_PTR)TRUE;
		}
		break;
	}
	return (INT_PTR)FALSE;
}
